unit LeadTools;

interface

uses
  Windows;

var
  LeadToolsLoaded: Boolean = False;

type
  L_Image = record
    _1, _2: Cardinal;
    Width, Height: Cardinal;
    UnknownData: array[1..$7C] of Byte;
    end;

var
  L_LoadFileOffset : function(FileHandle: THandle; FileOffset, FileSize: Integer; var Image: L_Image; p5, p6, p7, p8, p9: Integer) : Integer; stdcall; // True if OK
  L_ConvertToDIB : function(var Image: L_Image): hBitmap; stdcall;
  L_FreeBitmap : function(var Image: L_Image) : Boolean; stdcall;

implementation

uses
  Registry;

var
  WAPath: string;
  hFiles, hKernel: THandle;

initialization
  WAPath:='';

  with TRegistry.Create do
    try
      RootKey := HKEY_CURRENT_USER;
      OpenKey('Software\Team17SoftwareLTD\WormsArmageddon', False);
      WAPath:=ReadString('PATH');
    finally
      Free;
      end;

  if WAPath<>'' then
    begin
    hKernel := LoadLibrary(PChar(WAPath + '\ltkrn10N.dll'));
    if hKernel = 0 then
      hKernel := LoadLibrary(PChar(WAPath + '\ltkrn80n.dll'));

    hFiles := LoadLibrary(PChar(WAPath + '\ltfil10N.DLL'));
    if hFiles = 0 then
      hFiles := LoadLibrary(PChar(WAPath + '\ltfil80n.DLL'));

    if (hFiles<>0) and (hKernel<>0) then
      begin
      @L_LoadFileOffset := GetProcAddress ( hFiles , 'L_LoadFileOffset' );
      @L_ConvertToDIB   := GetProcAddress ( hKernel, 'L_ConvertToDIB' );
      @L_FreeBitmap     := GetProcAddress ( hKernel, 'L_FreeBitmap' );

      LeadToolsLoaded :=
        (@L_LoadFileOffset <> nil) and
        (@L_ConvertToDIB <> nil) and
        (@L_FreeBitmap <> nil);
      end;
    end;
end.